package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.entities.RiwayatPenyakitPengobatan;

import com.jasamedika.medifirst2000.vo.RiwayatPenyakitPengobatanVO;

@Component
public class RiwayatPenyakitPengobatanConverter implements BaseVoConverter<RiwayatPenyakitPengobatanVO, RiwayatPenyakitPengobatan> {


	@Override
	public RiwayatPenyakitPengobatan transferVOToModel(RiwayatPenyakitPengobatanVO vo, RiwayatPenyakitPengobatan model) {
		if (null == model)
			model = new RiwayatPenyakitPengobatan();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, RiwayatPenyakitPengobatan.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return model;
	}

	@Override
	public List<RiwayatPenyakitPengobatanVO> transferListOfModelToListOfVO(List<RiwayatPenyakitPengobatan> models, List<RiwayatPenyakitPengobatanVO> vos) {

		if (null == vos)
			vos = new ArrayList<RiwayatPenyakitPengobatanVO>();

		if (null == models)
			return vos;

		for (RiwayatPenyakitPengobatan riwayatPenyakitPengobatan : models) {
			RiwayatPenyakitPengobatanVO vo = new RiwayatPenyakitPengobatanVO();
			vo=transferModelToVO(riwayatPenyakitPengobatan, vo);
			vos.add(vo);
		}

		return vos;
	}

	@Override
	public RiwayatPenyakitPengobatanVO transferModelToVO(RiwayatPenyakitPengobatan model, RiwayatPenyakitPengobatanVO vo) {
		if (null == vo)
			vo = new RiwayatPenyakitPengobatanVO();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, RiwayatPenyakitPengobatanVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return vo;
	}
	
	public RiwayatPenyakitPengobatanVO transferModelToVOCustom(RiwayatPenyakitPengobatan model, RiwayatPenyakitPengobatanVO vo,String[] fieldsToInclude) {
		if (null == vo)

		vo = new RiwayatPenyakitPengobatanVO();

		try {
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, RiwayatPenyakitPengobatanVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return vo;
	}
	
	
	
	

}
